﻿using System;using System.Linq;using UnityEngine;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.XR;using System.Collections;using System.Collections.Generic;using SimpleJSON;using System.Text.RegularExpressions; namespace VaMPos{    public class PresetAdminister : MVRScript    {        List<string> GetAtomListChoices(string atomType,string namekeyword){   List<string> targetChoices = new List<string>();   targetChoices.Add("none");   foreach (string atomUID in SuperController.singleton.GetAtomUIDs()){ Atom atom = SuperController.singleton.GetAtomByUid(atomUID);             if (!string.IsNullOrEmpty(atomType)){                 if (atom != null && atom.type==atomType && atom.type!="AnimationStep" && atom.name.Contains(namekeyword)){       targetChoices.Add(atomUID); }}else{                 if (atom != null && atom.type!="AnimationStep" && atom.name.Contains(namekeyword) && atom!=containingAtom         && !atomSkipNameList.Any((str) => atom.name.Contains(str)) ){       targetChoices.Add(atomUID); }}   }   return targetChoices;}        string GetPluginID(string atomName,string keyword){      string pluginID="";   Atom atom= SuperController.singleton.GetAtomByUid(atomName);   if(atom!=null){      foreach (string receiverChoice in atom.GetStorableIDs()){if( receiverChoice.Contains("plugin#") && receiverChoice.Contains(keyword)){pluginID= receiverChoice;   return pluginID;}     }   }   return pluginID;}        void SetPluginChooser( string atomName, string pluginNameKeyWord, string chooserName, string value ){    Atom atom= SuperController.singleton.GetAtomByUid(atomName);    JSONStorable receiver = atom.GetStorableByID (GetPluginID(atomName,pluginNameKeyWord));    JSONStorableStringChooser chooser = receiver.GetStringChooserJSONParam(chooserName);    chooser.val = value;}        void CallPluginAction(string atomName,string pluginNameKeyWord, string actionName){    Atom atom= SuperController.singleton.GetAtomByUid(atomName);    JSONStorable receiver = atom.GetStorableByID (GetPluginID(atomName,pluginNameKeyWord));            receiver.CallAction(actionName);}bool GetSex(string atomName){   bool feMale = false;   Atom atom = SuperController.singleton.GetAtomByUid(atomName);    if( !atom ){ return feMale; }           if( !atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("male")&&        !atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarlee") && !atom.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarjulian")){       feMale = true;   }   return feMale;}        List<string> GetAudioListChoices(bool sceneAudio,string category){   List<string> targetChoices = new List<string>();   if( category == "web" ){ targetChoices.Add("none"); }   targetChoices.Add("Stop");   if(!sceneAudio){audioClips = EmbeddedAudioClipManager.singleton.GetCategoryClips(category);   }else{   audioClips = URLAudioClipManager.singleton.GetCategoryClips(category);   }   if (audioClips != null) {foreach (NamedAudioClip clip in audioClips) {targetChoices.Add(clip.displayName);}   }      return targetChoices;}void GetAudioSourceControl(string audioSource){     Atom atom= SuperController.singleton.GetAtomByUid(audioSource);if( !atom ){ return; }     source = atom.GetStorableByID("HeadAudioSource") as AudioSourceControl;     if(atom.type == "RhythmAudioSource"){  source = atom.GetStorableByID("RhythmSource") as AudioSourceControl; }     if(atom.type == "AudioSource"){  source = atom.GetStorableByID("AudioSource") as AudioSourceControl; }}float GetVolume(string audioSource){     GetAudioSourceControl(audioSource);     return source.volume;}void SetVolume(string audioSource, float volume){     if( audioSource == "none"){ return; }     GetAudioSourceControl(audioSource);     source.volume=volume;}void StopSound(){     if( uiSource.val == "none" ){ return; }     GetAudioSourceControl(uiSource.val);     source.CallAction("Stop");}void PlaySound( string audioSource, string audio, bool play, bool loop ){     if( audioSource == "none" || audio == "none" ){ return; }     GetAudioSourceControl(audioSource);     if( audio=="Stop" ){ source.CallAction("Stop");return; }     List<string> sceneAudioList = GetAudioListChoices(true,"web");     if( sceneAudioList.Any((str) => audio.Contains(str)) ){        audioClip = URLAudioClipManager.singleton.GetClip(audio);     }     else{ audioClip = EmbeddedAudioClipManager.singleton.GetClip(audio); }                       if( play && !loop ){  source.CallAction("PlayIfClear", audioClip); }          if( play && loop ){  source.CallAction("PlayNowLoop", audioClip); }}        private List<string> GetPeopleNamesFromScene()        {            return SuperController.singleton.GetAtoms()                    .Where(atom => atom.GetStorableByID("geometry") != null && atom != containingAtom)                    .Select(atom => atom.name).ToList();        }        AnimationPattern GetAnimationPattern(string atomName){    Atom atom= SuperController.singleton.GetAtomByUid(atomName);            animationPattern = atom.GetStorableByID("AnimationPattern") as AnimationPattern;            currentTime = animationPattern.GetFloatJSONParam("currentTime");    totalTime = animationPattern.GetTotalTime();    return animationPattern;}List<string> GetPoseChoices(){   List<string> targetChoices = new List<string>{ "none" };   List<string> poseTenNumList = new List<string>();   List<string> poseOtherList = new List<string>();   foreach (string atomUID in SuperController.singleton.GetAtomUIDs()){      Atom atom = SuperController.singleton.GetAtomByUid(atomUID);              if( atom.name.Contains("PoseBk")){ continue; }              if( atom.name == presetID + "Pose" ){ targetChoices.Add(atom.name);      }      else if( atom.name.Contains(presetID + "Pose#" ) && !atom.name.Contains("_cut") ){          string strTmp = atom.name.Replace(presetID + "Pose#", "");     bool valueIsNumeric = GetIsNumeric( strTmp ); if( valueIsNumeric ){    int num = int.Parse( strTmp );    if( num >= 10 ){ poseTenNumList.Add( atom.name ); } else{ targetChoices.Add(atom.name);  } }                 else{ poseOtherList.Add(atom.name); }      }              else if( atom.name.Contains(presetID + "Pose") ){ poseOtherList.Add(atom.name); }   }   if( poseTenNumList.Count > 0 ){ targetChoices.AddRange(poseTenNumList); }   if( poseOtherList.Count > 0 ){ targetChoices.AddRange(poseOtherList); }   return targetChoices;}        List<string> GetPoseListRangeChoices(){   List<string> poseList = GetPoseChoices();  poseList.Remove("none");      List<string> poseListRange = new List<string>();   bool start = false;   bool poseEnd = false;   if( uiStart.val == "none" ){ start = true; }   if( uiEnd.val != "none" ){ poseEnd = true; }   int i = 0;   foreach ( string posePreset in poseList ){       if( posePreset == uiStart.val ){ start = true; }       if( start && uiPreset.Length > i ){ poseListRange.Add( posePreset ); i++; }         if( poseEnd && posePreset == uiEnd.val ){ break; }   }   return poseListRange;}        List<string> GetPresetListChoices( bool range ){   if( uiStart.val == "none" && uiEnd.val == "none" ){ range = false; }   List<string> presetList = new List<string>();   presetList.Add("none");   foreach( string atomUID in SuperController.singleton.GetAtomUIDs() ){      Atom atom = SuperController.singleton.GetAtomByUid(atomUID);              if ( atom.type == "UIText" && atom.name.Contains( presetID ) && !atom.name.Contains( "Pose" ) ){         presetList.Add(atom.name);      }   }      List<string> poseList = GetPoseChoices();  poseList.Remove("none");   if( poseList.Count > 0 ){ presetList.AddRange( poseList ); }      if( range ){       List<string> presetListRange = new List<string>();       presetList.Remove("none");      presetListRange.Add("none");      bool start = false;      bool end = false;      if( uiStart.val == "none" ){ start = true; }      if( uiEnd.val != "none" ){ end = true; }      int i = 0;      foreach ( string preset in presetList ){          if( preset == uiStart.val ){ start = true; }          if( start && uiPreset.Length > i ){ presetListRange.Add( preset ); i++; }            if( end && preset == uiEnd.val ){ break; }      }      return presetListRange;   }   return presetList;}List<string> GetStringChooserChoices( string atomName, string receiver, string receiverTarget ){   List<string> targetChoices = new List<string>();   Atom atom = SuperController.singleton.GetAtomByUid( atomName );if( !atom ){ return targetChoices; }   JSONStorableStringChooser targetChooser = atom.GetStorableByID(receiver).GetStringChooserJSONParam(receiverTarget);   foreach (string choice in targetChooser.choices) {targetChoices.Add(choice);   }   return targetChoices;}        void SetTextControllerState( string atomName, string controllerName, string positionState, string rotationState ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);    if( !atom ){ return; }    FreeControllerV3 controller = atom.containingAtom.GetStorableByID(controllerName) as FreeControllerV3;    if( controller.currentPositionState.ToString() != positionState ){ controller.SetPositionStateFromString(positionState); }    if( controller.currentRotationState.ToString() != rotationState ){ controller.SetRotationStateFromString(rotationState); }}        void SetTextAtomTransform( string atomName, string controllerName, float posX, float posY, float posZ, float rot1, float rot2, float rot3, float rot4  ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }    FreeControllerV3 controller = atom.containingAtom.GetStorableByID(controllerName) as FreeControllerV3;    Transform atomTransform = controller.transform;            Vector3    valuePos = new Vector3( posX, posY, posZ );            Quaternion valueRot = new Quaternion( rot1, rot2, rot3, rot4 );    if( atomTransform.position != valuePos || atomTransform.rotation != valueRot ){            atomTransform.SetPositionAndRotation( valuePos, valueRot );    }}        void LerpTextAtomTransform( string atomName, string controllerName, float posX, float posY, float posZ, float rot1, float rot2, float rot3, float rot4  ){    float speed = 0.1f;    Atom atom = SuperController.singleton.GetAtomByUid(atomName);if( !atom ){ return; }    FreeControllerV3 controller = atom.containingAtom.GetStorableByID(controllerName) as FreeControllerV3;    Transform atomTransform = controller.transform;    Vector3 fromPosition = atomTransform.position;    Quaternion fromRotation = atomTransform.rotation;    Vector3 toPosition = new Vector3( posX, posY, posZ );    Quaternion toRotation = new Quaternion( rot1, rot2, rot3, rot4 );    atomTransform.position = Vector3.Lerp( fromPosition, toPosition, speed );    atomTransform.rotation = Quaternion.Lerp( fromRotation, toRotation, speed );}        void SetTextAtomOn( string atomName, string atomType, string on, string action ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }        if( on == "True" && atom.on == false && action == "none" ){  atom.SetOn(true); }    else if( on == "False" &&  atom.on == true && action == "none" ){ atom.SetOn(false); }        else if( action != "none" && atom.type == "AnimationPattern" ){                AnimationPattern animationPattern = atom.GetStorableByID("AnimationPattern") as AnimationPattern;                switch( action ){                  case "ON":   atom.SetOn(true);break;                  case "OFF":  atom.SetOn(false);break;                  case "ResetAndPlay":            animationPattern.ResetAndPlay();break;                  case "Play":            animationPattern.Play();break;                  case "Pause":            animationPattern.Pause();break;                  case "ResetAnimation":            animationPattern.Pause();            animationPattern.ResetAnimation();break;}    }    else{                switch( action ){                  case "ON":   atom.SetOn(true);break;                  case "OFF":  atom.SetOn(false);break;}    }}        void SetTextReceiverColor( string atomName,string receiver,string receiverTarget, string H, string S, string V){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }            if ( string.IsNullOrEmpty(H) || string.IsNullOrEmpty(S) || string.IsNullOrEmpty(V) ){ return; }            HSVColor color = new HSVColor();            color.H = float.Parse(H); color.S = float.Parse(S); color.V = float.Parse(V);        if( atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.H != color.H || atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.S != color.S || atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.V != color.V ){       atom.GetStorableByID(receiver).SetColorParamValue( receiverTarget, color );    }}        void SetTextBoolFloatReceiver( string atomName,string receiver,string receiverTarget, string value ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }            if ( string.IsNullOrEmpty(value) ){ return; }    bool valueIsNumeric = GetIsNumeric( value );        if( value == "True" ){    if( atom.GetStorableByID(receiver).GetBoolJSONParam(receiverTarget).val != true ){   atom.GetStorableByID(receiver).SetBoolParamValue( receiverTarget, true );     }    }    else if( value == "False" ){    if( atom.GetStorableByID(receiver).GetBoolJSONParam(receiverTarget).val != false ){   atom.GetStorableByID(receiver).SetBoolParamValue( receiverTarget, false );     }    }        else if( valueIsNumeric ){    if( atom.GetStorableByID(receiver).GetFloatJSONParam(receiverTarget).val != float.Parse(value) ){       atom.GetStorableByID(receiver).SetFloatParamValue( receiverTarget, float.Parse(value) );     }    }        else if( atom.GetStorableByID(receiver).GetStringChooserJSONParam(receiverTarget).val != value ){       atom.GetStorableByID(receiver).SetStringChooserParamValue( receiverTarget, value );    }}        void SetBoolReceiver( string atomName, string receiver, string receiverTarget, bool value){    Atom atom = SuperController.singleton.GetAtomByUid( atomName );   if( !atom ){ return; }    if( atom.GetStorableByID(receiver).GetBoolJSONParam(receiverTarget).val != value ){       atom.GetStorableByID(receiver).SetBoolParamValue( receiverTarget, value );    }}        bool GetBoolReceiver( string atomName, string receiver, string receiverTarget ){    Atom atom = SuperController.singleton.GetAtomByUid( atomName );   if( !atom ){ return false; }    JSONStorableBool receiverBool = atom.GetStorableByID(receiver).GetBoolJSONParam(receiverTarget);    return receiverBool.val;}        void SetFloatReceiver( string atomName, string receiver, string receiverTarget, float value){    Atom atom = SuperController.singleton.GetAtomByUid( atomName );   if( !atom ){ return; }    if( atom.GetStorableByID(receiver).GetFloatJSONParam(receiverTarget).val != value ){       atom.GetStorableByID(receiver).SetFloatParamValue( receiverTarget, value );    }}        float GetFloatReceiver( string atomName, string receiver, string receiverTarget ){    Atom atom = SuperController.singleton.GetAtomByUid( atomName );   if( !atom ){ return 0f; }    JSONStorableFloat receiverFloat = atom.GetStorableByID(receiver).GetFloatJSONParam(receiverTarget);    return receiverFloat.val;}void SetStringChooser( string atomName, string receiver, string receiverTarget, string value ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }    if( atom.GetStorableByID(receiver).GetStringChooserJSONParam(receiverTarget).val != value ){       atom.GetStorableByID(receiver).SetStringChooserParamValue(receiverTarget, value );    }}        string GetStringChooserValue( string atomName, string receiver, string receiverTarget ){    Atom atom = SuperController.singleton.GetAtomByUid( atomName );   if( !atom ){ return ""; }    JSONStorableStringChooser receiverStringChooser = atom.GetStorableByID(receiver).GetStringChooserJSONParam(receiverTarget);    return receiverStringChooser.val;}        string GetStringValue( string atomName, string receiver, string receiverTarget ){    Atom atom = SuperController.singleton.GetAtomByUid( atomName );   if( !atom ){ return ""; }    JSONStorableString receiverString = atom.GetStorableByID(receiver).GetStringJSONParam(receiverTarget);    return receiverString.val;}void SetString( string atomName, string receiver, string receiverTarget, string value ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }    if( atom.GetStorableByID(receiver).GetStringJSONParam(receiverTarget).val != value ){       atom.GetStorableByID(receiver).SetStringParamValue(receiverTarget, value );    }}        string GetUrlValue( string atomName, string receiver, string receiverTarget ){    Atom atom = SuperController.singleton.GetAtomByUid( atomName );   if( !atom ){ return ""; }    JSONStorableString receiverString = atom.GetStorableByID(receiver).GetUrlJSONParam(receiverTarget);    return receiverString.val;}void SetUrlReceiver( string atomName, string receiver, string receiverTarget, string value ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }    if( atom.GetStorableByID(receiver).GetUrlJSONParam(receiverTarget).val != value ){       atom.GetStorableByID(receiver).SetUrlParamValue(receiverTarget, value );    }}        void ReceiverCallAction(string atomName,string receiver, string value){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }    atom.GetStorableByID(receiver).CallAction(value);}void RemoveReceiver( string atomName, string receiverWord ){   string receiver = "geometry";   Atom atom = SuperController.singleton.GetAtomByUid( atomName );  if( !atom ){ return; }   JSONStorable receiverChoice = atom.GetStorableByID(receiver);   foreach (string receiverTarget in receiverChoice.GetBoolParamNames()){      if( receiverTarget.Contains( receiverWord ) ){bool value = GetBoolReceiver( atomName, receiver, receiverTarget );if( value ){           SetBoolReceiver( atomName, receiver, receiverTarget, false );}      }   }}        void PauseClear(){    posePause = false; waitNowTmp = ""; speedRestore();}        void MovieStart(){    poseLoop.val = false;uiNextPlay.val = "none";    if( japanese ){ langText = "ムービーPlay"; }else{ langText = "Movie Play"; }    if( movieInterval != 0f ){ MovieStop(); return; }    personConversion = false;            if( japanese ){ langText = "停止"; }else{ langText = "Stop"; }    moviePlayButton.label = langText;    EndClear();    AutoPosePreset();    movieInterval = movieSlider.val;    movieNo = 0;    PresetLoad( uiPreset[movieNo].val );    uiPresetSave.val = uiPreset[movieNo].val;}        void MovieStop(){    if( japanese ){ langText = "ムービー停止"; }else{ langText = "Movie Stop"; }            if( japanese ){ langText = "ムービーPlay"; }else{ langText = "Movie Play"; }    moviePlayButton.label = "ムービーPlay"; movieInterval = 0f;    personConversion = false;}        void MovieRandomInterval(){    float randomSpeed = 0f;    int rMin = 0;    int rMax = Mathf.FloorToInt( movieRandomMax.val );    int iRandom = r.Next(rMin, rMax);    int abs = r.Next(0, 2);    if( abs == 1 ){ randomSpeed = movieSlider.val + ( (float)iRandom/100); }    else{ randomSpeed = movieSlider.val - ( (float)iRandom/100); }    movieInterval = randomSpeed;    movieSlider.val = movieInterval;        if( movieSlider.val > ( movieSliderTmp + 0.5f) || movieSlider.val < ( movieSliderTmp - 0.5f)){ movieSlider.val = movieSliderTmp; }}        void MovieSync(){        if( !movieRandom.val ){ movieInterval = movieSlider.val; }    else{ MovieRandomInterval(); }    if( waitEndList.Count > 0 ){ return; }    if( stopInterval != 0f ){ return; }    if( waitNowName != "" || nextPoseText != "" ){ return; }    timerMovie.Reset(); timerMovie.Start();}        void MovieChange(){    timerMovie.Reset(); timerMovie.Stop();    movieNo++;    if( uiPreset[movieNo].val != "none" ){        EndClear();PresetLoad( uiPreset[movieNo].val );        uiPresetSave.val = uiPreset[movieNo].val;    }    else{ MovieEnd(); }}        void MovieEnd(){    EndClear();    movieInterval = 0f;    if( movieLoop.val ){ MovieStart(); }else{ MovieStop(); }}        void GetXyzEnd( string atomName, string controllerName ){   xyzEnd[xyzEndId,0] = atomName;   xyzEnd[xyzEndId,1] = controllerName;   xyzEnd[xyzEndId,2] = "false";   xyzEnd[xyzEndId,3] = "false";   xyzEnd[xyzEndId,4] = "false";   xyzEnd[xyzEndId,5] = "false";   xyzEnd[xyzEndId,6] = "false";   xyzEnd[xyzEndId,7] = "false";   xyzEnd[xyzEndId,8] = "false";   xyzEndId++;}        void GetNextPoseText(){   int controllerCount = 0;   bool start = false;   nextPoseText = "";      string text= GetAtomText( poseNowPreset );    if ( string.IsNullOrEmpty(text) ){ return; }   text = DeleteEmptyLine( text );   string[] line = text.Replace("\r\n","\n").Split(new[]{'\n','\r'});   for( int i = 0; i < line.Length; i++ ){      string[] lineValue =  line[i].Split(',');      string receiver = lineValue[0];      if( receiver == waitNowName ){ start = true;}      if( start && receiverAnimeList.Any((str) => receiver == str ) ){ controllerCount++; }      if( receiver.Contains("待機時間") && !waitEndList.Any((str) => receiver.Contains(str)) ){   waitNextTmp = receiver;  break;   }      if( receiver == "End" ){ break; }   }      if( controllerCount == 0 ){ waitNowName = "";  PresetLoad( poseNowPreset ); return; }   else{   start = false;      endControllerList = new List<string>();    endScaleList = new List<string>();    xyzEnd= new string[controllerCount,9];    xyzEndId = 0;   for( int i = 0; i < line.Length; i++ ){      string[] lineValue =  line[i].Split(',');      string receiver = lineValue[0];      if( receiver == waitNowName ){ start = true; }      if( start && ( receiverAnimeList.Any((str) => receiver == str ) || targetAtomList.Any((str) => receiver == str )  || targetLightList.Any((str) => receiver == str ) ) ){ nextPoseText = nextPoseText + line[i] + "\r\n";           waitPoseTmp =  line[i];  string atomName = lineValue[1];         if( receiver == "PersonController:" || receiver == "カメラ:" ){ string controllerName = lineValue[2]; GetXyzEnd( atomName, controllerName ); }         if( receiver == "Atom:" ){ string controllerName = lineValue[3]; GetXyzEnd( atomName, controllerName ); }      }      if( receiver.Contains("待機時間") && !waitEndList.Any((str) => receiver.Contains(str)) ){ waitNowName = ""; break; }      if( receiver == "End" ){ waitNowName = ""; endControllerList = new List<string>();  endScaleList = new List<string>(); break; }   }   if ( string.IsNullOrEmpty(nextPoseText) ){ PresetLoad( poseNowPreset ); }   nextPoseText = DeleteEmptyLine( nextPoseText );   }}        void PoseLoad(){      List<bool> changeList = new List<bool>();      List<bool> changeScaleList = new List<bool>();      List<bool> changeCameraList = new List<bool>();   int count = 0; int countScale = 0; int countCamera = 0;   string atomName = ""; string controllerName = ""; string positionState = ""; string rotationState = "";   float posX = 0; float posY = 0; float posZ = 0; float rot1 = 0; float rot2 = 0; float rot3 = 0; float rot4 = 0;   float playerHeightAdjust = 0;    string[] line = nextPoseText.Replace("\r\n","\n").Split(new[]{'\n','\r'});   for( int i = 0; i < line.Length; i++ ){          string[] lineValue =  line[i].Split(',');     if( lineValue.Length < 12 && lineValue.Length != 4 && lineValue.Length != 6 && lineValue.Length != 11 ){ continue; }  string receiver = lineValue[0];          atomName = lineValue[1];  if( receiver == "PersonController:" ){              controllerName = lineValue[2];             positionState = lineValue[3];             rotationState = lineValue[4];             posX = float.Parse( lineValue[5] );             posY = float.Parse( lineValue[6] );             posZ = float.Parse( lineValue[7] );             rot1 = float.Parse( lineValue[8] );             rot2 = float.Parse( lineValue[9] );             rot3 = float.Parse( lineValue[10] );             rot4 = float.Parse( lineValue[11] );  }  if( receiver == "Atom:" ){              controllerName = lineValue[3];             positionState = lineValue[5];             rotationState = lineValue[6];             posX = float.Parse( lineValue[7] );             posY = float.Parse( lineValue[8] );             posZ = float.Parse( lineValue[9] );             rot1 = float.Parse( lineValue[10] );             rot2 = float.Parse( lineValue[11] );             rot3 = float.Parse( lineValue[12] );             rot4 = float.Parse( lineValue[13] );  }  if( receiver == "カメラ:" && cameraAction.val ){              controllerName = lineValue[2];             posX = float.Parse( lineValue[3] );             posY = float.Parse( lineValue[4] );             posZ = float.Parse( lineValue[5] );             rot1 = float.Parse( lineValue[6] );             rot2 = float.Parse( lineValue[7] );             rot3 = float.Parse( lineValue[8] );             rot4 = float.Parse( lineValue[9] );               playerHeightAdjust = float.Parse( lineValue[10] );  }    if( targetAtomList.Any((str) => receiver == str ) || targetLightList.Any((str) => receiver == str ) ){          Atom atom = SuperController.singleton.GetAtomByUid(atomName);if( !atom ){ continue; }             string receiverTarget = lineValue[2];  　 if( endScaleList.Any((str) => ( ( atomName + receiverTarget) == str ) ) ){ continue; }          if( lineValue.Length == 4 ){                string value = lineValue[3];        changeScaleList.Add( false );        changeScaleList[countScale] = ChangeBoolFloat( atomName, receiver, receiverTarget, value );        countScale++;     }                          if( lineValue.Length == 6 && receiverTarget.Contains("olor") ){                string H = lineValue[3];                string S = lineValue[4];                string V = lineValue[5];         changeScaleList.Add( false );                    changeScaleList[countScale] = ChangeColor( atomName, receiver, receiverTarget, H, S, V );        countScale++;             }  }            if( positionState == "Off" && rotationState == "Off" ){ continue; }         if( endControllerList.Any((str) => ( ( atomName + controllerName) ==str ) ) ){ continue; }            if( receiver != "カメラ:" ){     changeList.Add( false );     changeList[count] = ChangeTransform( atomName, controllerName, posX, posY, posZ, rot1, rot2, rot3, rot4 );     count++;  }  else if( cameraAction.val ){      changeCameraList.Add( false );     changeCameraList[countCamera] = ChangeCamera( atomName, controllerName, posX, posY, posZ, rot1, rot2, rot3, rot4, playerHeightAdjust );     countCamera++;  }    }            int waitMax = 10;                if( count == 0 || !changeList.Contains(true) || timer.ElapsedMilliseconds > timeInterval  ) {       if(  !changeScaleList.Contains(true) && !changeCameraList.Contains(true) ) { if( poseSet.val ){ SetPose(); }         timeInterval =0; nextPoseText = ""; endControllerList = new List<string>(); endScaleList = new List<string>(); PresetLoad( poseNowPreset );       }    }}        void SpeedRandom( float sourceSpeed, ref float speed, float low, float up ){    float randomSpeed = 2f;    int rMin = Mathf.FloorToInt( sourceSpeed - low );    if( rMin <=1 ){ rMin = 1; }    int rMax = Mathf.FloorToInt( sourceSpeed + up );    int iRandom = r.Next(rMin, rMax);    int abs = r.Next(0, 2);    if( abs == 1 ){ randomSpeed = sourceSpeed + (float)iRandom; }    else if( sourceSpeed - iRandom > 2 ){ randomSpeed = sourceSpeed - (float)iRandom; }    speed = randomSpeed;}        bool ChangeTransform( string atomName, string controllerName, float posX, float posY, float posZ, float rot1, float rot2, float rot3, float rot4  ){    bool change = true;    float limitTmp = limitSlider.val;    if( randomSpeed.val && speedSlider.val < 7 ){ SpeedRandom( limitSlider.val, ref limitTmp, 0f, 4f ); }    timeInterval = limitTmp * 1000;    timeInterval = timeInterval / speedSlider.val;    float speedTmp = speedSlider.val;    if( randomSpeed.val ){ SpeedRandom( speedSlider.val, ref speedTmp, -2f, 2f ); }            float speed = speedTmp / 100;    if( controllerName == "eyeTargetControl" ){ speed = speed * 40; }    Atom atom = SuperController.singleton.GetAtomByUid(atomName);if( !atom ){ return true; }    FreeControllerV3 controller = atom.containingAtom.GetStorableByID(controllerName) as FreeControllerV3;    Transform atomTransform = controller.transform;            Vector3 fromPosition = atomTransform.position;            Quaternion fromRotation = atomTransform.rotation;            Vector3 toPosition = new Vector3( posX, posY, posZ );            Quaternion toRotation = new Quaternion( rot1, rot2, rot3, rot4 );    if( fromPosition == toPosition && fromRotation == toRotation ){endControllerList.Add( atomName + controllerName );change = false; return change;    }            atomTransform.position = Vector3.Lerp( fromPosition, toPosition, speed );            atomTransform.rotation = Quaternion.Lerp( fromRotation, toRotation, speed );    if( fromPosition == toPosition && fromRotation == toRotation ){endControllerList.Add( atomName + controllerName );change = false; return change;    }    return change;}        void SetPose()        {    string atomName = ""; string controllerName = ""; string positionState = ""; string rotationState = "";    float posX = 0; float posY = 0; float posZ = 0; float rot1 = 0; float rot2 = 0; float rot3 = 0; float rot4 = 0;    float playerHeightAdjust = 0;     string[] line = nextPoseText.Replace("\r\n","\n").Split(new[]{'\n','\r'});    for( int i = 0; i < line.Length; i++ ){      string[] lineValue =  line[i].Split(',');      if( lineValue.Length < 12 && lineValue.Length != 4 && lineValue.Length != 11 ){ continue; }      string receiver = lineValue[0];      atomName = lineValue[1];      if( receiver == "PersonController:" ){           controllerName = lineValue[2];          positionState = lineValue[3];          rotationState = lineValue[4];          posX = float.Parse( lineValue[5] );          posY = float.Parse( lineValue[6] );          posZ = float.Parse( lineValue[7] );          rot1 = float.Parse( lineValue[8] );          rot2 = float.Parse( lineValue[9] );          rot3 = float.Parse( lineValue[10] );          rot4 = float.Parse( lineValue[11] );                    SetTextAtomTransform( atomName, controllerName, posX, posY, posZ, rot1, rot2, rot3, rot4 );      }      if( receiver == "Atom:" ){           controllerName = lineValue[3];          positionState = lineValue[5];          rotationState = lineValue[6];          posX = float.Parse( lineValue[7] );          posY = float.Parse( lineValue[8] );          posZ = float.Parse( lineValue[9] );          rot1 = float.Parse( lineValue[10] );          rot2 = float.Parse( lineValue[11] );          rot3 = float.Parse( lineValue[12] );          rot4 = float.Parse( lineValue[13] );                    SetTextAtomTransform( atomName, controllerName, posX, posY, posZ, rot1, rot2, rot3, rot4 );      }      if( receiver == "カメラ:" && cameraAction.val ){           controllerName = lineValue[2];          posX = float.Parse( lineValue[3] );          posY = float.Parse( lineValue[4] );          posZ = float.Parse( lineValue[5] );          rot1 = float.Parse( lineValue[6] );          rot2 = float.Parse( lineValue[7] );          rot3 = float.Parse( lineValue[8] );          rot4 = float.Parse( lineValue[9] );            playerHeightAdjust = float.Parse( lineValue[10] );  SetCamera( atomName, controllerName, posX, posY, posZ, rot1, rot2, rot3, rot4, playerHeightAdjust );      }    }}        bool ChangeCamera( string atomName, string controllerName, float posX, float posY, float posZ, float rot1, float rot2, float rot3, float rot4, float playerHeightAdjust ){    bool change = true;            float speed = speedSlider.val / 100;        if( atomName != "none" && controllerName != "none" ){       Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return false; }       FreeControllerV3 controller = atom.containingAtom.GetStorableByID(controllerName) as FreeControllerV3;   if( !controller ){ return false; }       SuperController.singleton.SelectController( controller );       SuperController.singleton.FocusOnSelectedController();    }    Transform atomTransform = SuperController.singleton.navigationRig.transform;            Vector3 fromPosition = atomTransform.position;            Quaternion fromRotation = atomTransform.rotation;            Vector3 toPosition = new Vector3( posX, posY, posZ );            Quaternion toRotation = new Quaternion( rot1, rot2, rot3, rot4 );            atomTransform.position = Vector3.Lerp( fromPosition, toPosition, speed );            atomTransform.rotation = Quaternion.Lerp( fromRotation, toRotation, speed );                float fromPlayer = SuperController.singleton.playerHeightAdjust;            float toPlayer = playerHeightAdjust;    if( fromPlayer > toPlayer ){ fromPlayer = fromPlayer - speed/10; if( fromPlayer < toPlayer ){ fromPlayer = toPlayer; } }    else if( fromPlayer < toPlayer ){ fromPlayer = fromPlayer + speed/10; if( fromPlayer > toPlayer ){ fromPlayer = toPlayer; } }        SuperController.singleton.playerHeightAdjust = fromPlayer;        if( fromPlayer == toPlayer  ){        atomTransform.SetPositionAndRotation( toPosition, toRotation );change = false;    }    return change;}        bool ChangeBoolFloat( string atomName,string receiver,string receiverTarget, string value ){    Atom atom = SuperController.singleton.GetAtomByUid(atomName);if( !atom ){ return true; }    bool change = true;            float speed = speedSlider.val / 100;    if( receiver.Contains( "PostMagic.DepthOfField" ) ){ speed = 0.5f; }     bool valueIsNumeric = GetIsNumeric( value );        if( value == "True" ){change = false;endScaleList.Add( atomName + receiverTarget );    if( atom.GetStorableByID(receiver).GetBoolJSONParam(receiverTarget).val != true ){   atom.GetStorableByID(receiver).SetBoolParamValue( receiverTarget, true );     }    }    else if( value == "False" ){change = false;endScaleList.Add( atomName + receiverTarget );    if( atom.GetStorableByID(receiver).GetBoolJSONParam(receiverTarget).val != false ){   atom.GetStorableByID(receiver).SetBoolParamValue( receiverTarget, false );     }    }        else if( valueIsNumeric ){               float fromScale = GetFloatReceiver( atomName, receiver, receiverTarget );               float toScale = float.Parse(value);       if( fromScale > toScale ){ fromScale = fromScale - speed;   if( fromScale <= toScale  ){ fromScale = toScale;  } }       if( fromScale < toScale ){ fromScale = fromScale + speed;   if( fromScale >= toScale  ){ fromScale = toScale;  } }               SetFloatReceiver( atomName, receiver, receiverTarget, fromScale );       if( fromScale == toScale ){  change = false;  endScaleList.Add( atomName + receiverTarget );       }    }    else{ return false; }    return change;}        bool ChangeColor( string atomName,string receiver,string receiverTarget, string H, string S, string V){    bool change = true;            float speed = speedSlider.val / 100;    Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return false; }            if ( string.IsNullOrEmpty(H) || string.IsNullOrEmpty(S) || string.IsNullOrEmpty(V) ){ return false; }            HSVColor color = new HSVColor();            float fromH = atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.H;            float fromS = atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.S;            float fromV = atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.V;            float toH = float.Parse(H);  float toS = float.Parse(S);  float toV = float.Parse(V);    if( fromH > toH ){ fromH = fromH - speed;   if( fromH <= toH  ){ fromH = toH;  } }    if( fromH < toH ){ fromH = fromH + speed;   if( fromH >= toH  ){ fromH = toH;  } }    if( fromS > toS ){ fromS = fromS - speed;   if( fromS <= toS  ){ fromS = toS;  } }    if( fromS < toS ){ fromS = fromS + speed;   if( fromS >= toS  ){ fromS = toS;  } }    if( fromV > toV ){ fromV = fromV - speed;   if( fromV <= toV  ){ fromV = toV;  } }    if( fromV < toV ){ fromV = fromV + speed;   if( fromV >= toV  ){ fromV = toV;  } }            color.H = fromH; color.S = fromS; color.V = fromV;    if( atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.H != color.H || atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.S != color.S || atom.GetStorableByID(receiver).GetColorJSONParam(receiverTarget).val.V != color.V ){       atom.GetStorableByID(receiver).SetColorParamValue( receiverTarget, color );    }    if( fromH == toH &&  fromS == toS &&  fromV == toV ){change = false;endScaleList.Add( atomName + receiverTarget );    }    return change;}        void EndClear(){   speedRestore(); randomSpeed.val = false;   posePause = false; poseNowPreset = ""; waitNowName = ""; nextPoseText = "";  waitPoseTmp = "";   waitEndList = new List<string>(); stopEndList = new List<string>();   timer.Reset(); timer.Stop();}        void SetCamera( string atomName, string controllerName, float posX, float posY, float posZ, float rot1, float rot2, float rot3, float rot4, float playerHeightAdjust ){    Transform camera = SuperController.singleton.navigationRig.transform;            Vector3    toPosition = new Vector3( posX, posY, posZ );            Quaternion toRotation = new Quaternion( rot1, rot2, rot3, rot4 );    if( camera.position != toPosition || camera.rotation != toRotation ){            camera.SetPositionAndRotation( toPosition, toRotation );    }    SuperController.singleton.playerHeightAdjust = playerHeightAdjust;        if( atomName != "none" && controllerName != "none" ){       Atom atom = SuperController.singleton.GetAtomByUid(atomName);   if( !atom ){ return; }       FreeControllerV3 controller = atom.containingAtom.GetStorableByID(controllerName) as FreeControllerV3;   if( !controller ){ return; }       SuperController.singleton.SelectController( controller );       SuperController.singleton.FocusOnSelectedController();    }}void GetCyclePluginChange(){   if ( allCycle.val ){ targetPluginList = new List<string>{ "CycleForce","Passenger" }; }   else{ targetPluginList = new List<string>{ "Passenger" }; }}        void PresetLoad(string presetName){   if( presetName == "none" ){ return; }   if( !personConversion ){ PersonConversion(); }   string text= GetAtomText( presetName );           if ( string.IsNullOrEmpty(text) ){ return; }      if( presetName != poseNowPreset ){  poseLoad = false; waitNowName = ""; waitEndList = new List<string>(); }      GetCyclePluginChange();   List<string> receiverTargetList = new List<string>{};   receiverTargetList.AddRange(targetClothingList);   receiverTargetList.AddRange(targetLightList);   receiverTargetList.AddRange(targetAPList);   receiverTargetList.AddRange(targetPluginList);   receiverTargetList.AddRange(targetSkinList);   receiverTargetList.AddRange(targetBreastList);      if( uiPerson.val != "none" && receiverClothingList.Any((str) => text.Contains(str)) && textEndList.Count() == 0 ){      if( clothingReset.val ){ RemoveReceiver( uiPerson.val, "clothing:" ); }      if( hairReset.val ){ RemoveReceiver( uiPerson.val, "hair:" ); }   }   text = DeleteEmptyLine( text );   string[] line = text.Replace("\r\n","\n").Split(new[]{'\n','\r'});   for( int i = 0; i < line.Length; i++ ){      string[] lineValue =  line[i].Split(',');      string receiver = lineValue[0];            if( receiver == "実行条件：" && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );   int judgePoint = int.Parse( lineValue[1] );   string badPreset = lineValue[2];       Atom atom = SuperController.singleton.GetAtomByUid(gamePointID);     if( atom ){     int gamePoint = int.Parse( GetStringValue( gamePointID, "Text", "text" ) );     if( judgePoint > gamePoint || gameTimerLimit != 0f ){        uiPresetSave.val = badPreset; PresetLoad( uiPresetSave.val ); return;     }  }      }            else if( receiver == "Gameリセット：" && !textEndList.Any((str) => line[i] == str) ){   textEndList.Add( line[i] );  GameReset();            if( lineValue.Length >= 3 ){     string point = lineValue[2];             if( point != "none" ){                Atom atom = SuperController.singleton.GetAtomByUid(gamePointID);       if( atom ){ SetString( atom.name, "Text", "text", point ); }           }          }      }            else if( receiver == "Pause：" && !textEndList.Any((str) => line[i] == str) ){   textEndList.Add( line[i] ); posePause =! posePause; personConversion = false;      }            else if( receiver == "Gameタイマー：" && !gameTimerEndList.Any((str) => presetName == str) ){  gameTimerEndList.Add( presetName );  gameTimerLimit = float.Parse( lineValue[1] );  string preset = lineValue[2];     Atom atom = SuperController.singleton.GetAtomByUid(preset);  if( atom ){      uiGameTimerPlay.val = preset; gameTimer.Reset(); gameTimer.Start();  }      }            else if( receiver == "キーボード：" && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );  int id = int.Parse( lineValue[1] );  string keyboard = lineValue[2];   string admin = lineValue[3];   string preset = lineValue[4];     Atom atom = SuperController.singleton.GetAtomByUid(admin);  if( atom ){         for( int j = 0; j < uiKeyboards.Length; j++ ){                 if( j == id ){            SetPluginChooser( admin,"PresetAdminister","ToggleKey"+id.ToString(), keyboard );           SetPluginChooser( admin,"PresetAdminister","EventPlay"+id.ToString(), preset );                }             }  }      }            else if( receiver == "点数：" && !textEndList.Any((str) => line[i] == str) && !pointEndList.Any((str) => presetName.Contains(str)) ){  textEndList.Add( line[i] );   int value = int.Parse( lineValue[1] );  string pointDouble = lineValue[2];      if( pointDouble == "False" ){  pointEndList.Add( presetName ); }     Atom atom = SuperController.singleton.GetAtomByUid(gamePointID);     if( atom ){     int gamePoint = int.Parse( GetStringValue( gamePointID, "Text", "text" ) );     if( value < 0 ){ gamePoint = gamePoint - Math.Abs(value); }     else{ gamePoint = gamePoint + value; }     SetString( atom.name, "Text", "text", gamePoint.ToString() );  }      }            else if( receiver == "スピード：" && !fastForward ){ speedSlider.val = float.Parse( lineValue[1] ); }            else if( receiver == "スピードランダム：" && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );   string value = lineValue[1];      if( value == "True" ){  randomSpeed.val = true; }else if( value == "False" ){ randomSpeed.val = false; }      }            else if( receiver == "リミット：" && !fastForward ){ limitSlider.val = float.Parse( lineValue[1] ); }            else if( receiver == "リミット強制変化：" ){   string value = lineValue[1];      if( value == "True" ){  poseSet.val = true; }else if( value == "False" ){ poseSet.val = false; }      }            else if( receiver.Contains("Pose停止") && !fastForward && !stopEndList.Any((str) => receiver.Contains(str)) ){  stopEndList.Add(receiver);          stopInterval = float.Parse( lineValue[1] ); timerStopPose.Reset(); timerStopPose.Start();      }            else if( receiver == "カメラ:" && lineValue.Length == 11 && timeInterval == 0  && cameraAction.val ){          string atomName = lineValue[1];          string controllerName = lineValue[2];          float posX = float.Parse( lineValue[3] );          float posY = float.Parse( lineValue[4] );          float posZ = float.Parse( lineValue[5] );          float rot1 = float.Parse( lineValue[6] );          float rot2 = float.Parse( lineValue[7] );          float rot3 = float.Parse( lineValue[8] );          float rot4 = float.Parse( lineValue[9] );            float playerHeightAdjust = float.Parse( lineValue[10] );        }            else if( receiver == "LOADポーズ:" && !textEndList.Any((str) => line[i].Contains(str)) ){  textEndList.Add( line[i] );          string atomName = lineValue[1];          string loadPath = lineValue[2];  if( loadPath != "false" ){        Atom atom = SuperController.singleton.GetAtomByUid( atomName );             if( atom ){ atom.LoadPhysicalPreset(  _vamFilePath + loadPath ); }  }      }            else if( !poseLoad && receiver.Contains("待機時間") && !waitEndList.Any((str) => receiver.Contains(str)) ){  waitEndList.Add(receiver);  waitNowName = receiver;  poseNowPreset = presetName;  timer.Reset(); timer.Start();  break;      }      else if( receiver == "End" ){  EndClear(); poseLoad = true;  }            else if( receiver == "PersonController:" && timeInterval == 0 ){          string atomName = lineValue[1];          string controllerName = lineValue[2];          string positionState = lineValue[3];          string rotationState = lineValue[4];  SetTextControllerState( atomName, controllerName, positionState, rotationState );      }            else if( receiver == "SubTitle:" && lineValue.Length > 5 && !textEndList.Any((str) => line[i].Contains(str)) ){  textEndList.Add( line[i] );          string atomName = lineValue[1];          string atomType = lineValue[2];          string receiverName = lineValue[3];          string receiverTarget = lineValue[4];          string value = lineValue[5];      SetString( atomName, receiverName, receiverTarget, value );      }            else if( receiver == "Expression:" ){          string atomName = lineValue[1];          string receiverName = lineValue[2];          string receiverTarget = lineValue[3];          string value = lineValue[4];  SetStringChooser( atomName, receiverName, receiverTarget, value );  ReceiverCallAction( atomName, receiverName, "表情Execute" );      }            else if( receiver == "Sound:" && !textEndList.Any((str) => line[i].Contains(str)) ){  textEndList.Add( line[i] );  bool loop = false;          string source = lineValue[1];          string audio = lineValue[2];          string volume = lineValue[3];      if( lineValue[4] == "True" ){  loop = true; }      else{ loop = false; }  SetVolume( source, float.Parse(volume) );          PlaySound( source, audio, true, loop );      }            else if( receiver == "Atom:" && lineValue.Length >= 14 && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );          string atomName = lineValue[1];          string atomType = lineValue[2];          string controllerName = lineValue[3];          string controllerOn = lineValue[4];          string positionState = lineValue[5];          string rotationState = lineValue[6];          float posX = float.Parse( lineValue[7] );          float posY = float.Parse( lineValue[8] );          float posZ = float.Parse( lineValue[9] );          float rot1 = float.Parse( lineValue[10] );          float rot2 = float.Parse( lineValue[11] );          float rot3 = float.Parse( lineValue[12] );          float rot4 = float.Parse( lineValue[13] );                  if( atomType == "InvisibleLight" ){      StartCoroutine( AddAtomMatch( atomType, atomName, controllerName, controllerOn, posX, posY, posZ, rot1, rot2, rot3, rot4  )) ;   }          string action = "none";                  if( lineValue.Length >= 15 ){ action = lineValue[14]; }          SetTextAtomOn( atomName, atomType, controllerOn, action );  SetTextControllerState( atomName, controllerName, positionState, rotationState );      }            else if( receiverClothingList.Any((str) => receiver.Contains(str)) && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );          string atomName = lineValue[1];            SetBoolReceiver( atomName, "geometry", receiver, true );      }            else if ( lineValue.Length >= 4 && receiverTargetList.Any((str) => receiver.Contains(str)) && !targetSkipList.Any((str) => receiver.Contains(str)) && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );          string atomName = lineValue[1];          string receiverTarget = lineValue[2];                        if( lineValue.Length == 6 && receiverTarget.Contains("olor")  ){             string H = lineValue[3];             string S = lineValue[4];             string V = lineValue[5];                 SetTextReceiverColor( atomName, receiver, receiverTarget, H, S, V );          }                    else if( lineValue.Length == 4  && receiveUrlList.Any((str) => receiverTarget.Contains(str))  ){             string value = lineValue[3];                 SetUrlReceiver( atomName, receiver, receiverTarget, value );          }            else if( lineValue.Length == 4 ){             string value = lineValue[3];                 SetTextBoolFloatReceiver( atomName, receiver, receiverTarget, value );       }       }            else if( receiver == "PersonPlugin:" && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );          string atomName = lineValue[1];          string pluginName = lineValue[2];          string value = lineValue[3];              SetTextBoolFloatReceiver( atomName, pluginName, "enabled", value );      }            else if( receiver == "PersonCycle:" && lineValue.Length == 12 ){          string atomName = lineValue[1];          string pluginName = lineValue[2];          string enabled = lineValue[3];          string part = lineValue[4];          string forceAxis = lineValue[5];          string torqueAxis = lineValue[6];          string forceFactor = lineValue[7];          string torqueFactor = lineValue[8];          string masterSlider = lineValue[9];          string period = lineValue[10];          string periodRatio = lineValue[11];              SetTextBoolFloatReceiver( atomName, pluginName, "enabled", enabled );              if( part != "none" ){ SetStringChooser( atomName, pluginName, "receiver", part ); }              SetStringChooser( atomName, pluginName, "forceAxis", forceAxis );              SetStringChooser( atomName, pluginName, "torqueAxis", torqueAxis );              SetTextBoolFloatReceiver( atomName, pluginName, "forceFactor", forceFactor );              SetTextBoolFloatReceiver( atomName, pluginName, "torqueFactor", torqueFactor );              SetTextBoolFloatReceiver( atomName, pluginName, "MasterSlider", masterSlider );              SetTextBoolFloatReceiver( atomName, pluginName, "period", period );              SetTextBoolFloatReceiver( atomName, pluginName, "periodRatio", periodRatio );      }            else if( receiver == "PersonCollision:" && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );          string atomName = lineValue[1];          string receiverName = lineValue[2];          string receiverTarget = lineValue[3];          string value = lineValue[4];              SetTextBoolFloatReceiver( atomName, receiverName, receiverTarget, value );      }            else if( receiver == "PersonLookMode:" || receiver == "PersonAutoExpressions:" ){          string atomName = lineValue[1];          string receiverAutoName = lineValue[2];          string receiverTarget = lineValue[3];          string value = lineValue[4];      if( value == "True" ){  SetBoolReceiver( atomName, receiverAutoName, receiverTarget, true ); }          else if( value == "False" ){ SetBoolReceiver( atomName, receiverAutoName, receiverTarget, false ); }      else{  SetStringChooser( atomName, receiverAutoName, receiverTarget, value ); }      }            else if( receiver == "GravityControl:" ){          xSlider.val = float.Parse( lineValue[1] );     ySlider.val = float.Parse( lineValue[2] );          zSlider.val = float.Parse( lineValue[3] );     xMSlider.val = float.Parse( lineValue[4] );          yMSlider.val = float.Parse( lineValue[5] );    zMSlider.val = float.Parse( lineValue[6] );      }            else if( receiver == "Poseループ：" && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );   string value = lineValue[1];      if( value == "True" ){  poseLoop.val = true; }else if( value == "False" ){ poseLoop.val = false; }      }            else if( receiver == "次の再生：" && !textEndList.Any((str) => line[i] == str) ){  textEndList.Add( line[i] );   string value = lineValue[1];      uiNextPlay.val = value;      }            if( i == line.Length-1 ){   textEndList = new List<string>();  if( uiNextPlay.val != "none" ){      uiPresetSave.val = uiNextPlay.val; PresetLoad( uiPresetSave.val );  uiNextPlay.val = "none";   }  if( poseLoop.val ){ PresetLoad( uiPresetSave.val ); poseLoop.val = false; }      }   }}        void GameReset(){    gameTimerEndList = new List<string>();     gameTimerLimit = 0f; gameTimer.Reset(); gameTimer.Stop(); uiGameTimerPlay.val = "none";    Atom atom = SuperController.singleton.GetAtomByUid(gamePointID);    if( atom ){ SetString( atom.name, "Text", "text", "0" ); }    atom = SuperController.singleton.GetAtomByUid(gameTimerID);    if( atom ){ SetString( atom.name, "Text", "text", "0" ); }    KeyboardClear();}        void KeyboardClear(){    for( int i = 0; i < uiKeyboards.Length; i++ ){        _toggleKeys[i] = KeyCode.None; uiKeyboards[i].val = "None"; uiEventPlays[i].val = "none";    }}        void ClearPosePreset()        {    for( int i = 0; i < uiPreset.Length; i++ ){ uiPreset[i].val = "none"; }        }        void AutoPosePreset()        {    ClearPosePreset();    List<string> presetList = GetPresetListChoices( true );    if( uiStart.val == "none" && uiEnd.val == "none" ){ presetList = GetPoseListRangeChoices(); }     presetList.Remove("none"); presetList.Remove(presetID + "PoseBk");    int i = 0;    foreach ( string preset in presetList ){       string text= GetAtomText( preset );       Atom atom = SuperController.singleton.GetAtomByUid( preset ); if( !atom ){ continue; }               if ( atom.hidden == true ){ continue; }               if ( string.IsNullOrEmpty(text) ){ continue; }       if( uiPreset.Length > i ){ uiPreset[i].val = preset; i++;  }    }}        void SyncPlay(){    GetAnimationPattern( uiTargetAP.val );     JSONStorableBool loop = animationPattern.GetBoolJSONParam("loop");                if( loop.val.ToString() == "True" && (currentTime.val >= totalTime + 1f || (currentTime.val >= 0.01f && currentTime.val <= 0.04f)) ){     for( int i = 0; i < uiPlayTimeSliders.Length; i++ ){playActionTemps[i] = false;    }    }        if( currentTime.val == 0.01f ){   for( int i = 0; i < uiPlayTimeSliders.Length; i++ ){playActionTemps[i] = false;    }    }        for( int i = 0; i < uiPlayTimeSliders.Length; i++ ){       if( !playActionTemps[i] && uiPlayTimeSliders[i] != null &&    currentTime.val > uiPlayTimeSliders[i].val && currentTime.val != totalTime){       ActionPlay(i);       }    }}        void ActionPlay(int i){    playActionTemps[i] = true;    if( uiPreset[i].val != "none" ){  EndClear(); PresetLoad( uiPreset[i].val ); }}        void RefreshListChoices(){    List<string> presetList = GetPresetListChoices( false );    uiPresetSave.choices = presetList;    uiStart.choices = presetList;    uiEnd.choices = presetList;    uiPresetAnime.choices = GetAtomListChoices("UIText",presetAnimeID);}        void TempTargetPresetAnimeUpdate(){   if( uiPresetAnime.val != "none" && uiPresetAnime.val != presetAnimeTemp ){        PresetAnimeLoad();presetAnimeTemp = uiPresetAnime.val;targetAPTemp = uiTargetAP.val;   }}        void PresetAnimeLoad(){   if( uiPresetAnime.val == "none" ){ return; }   string text= GetAtomText( uiPresetAnime.val );           if ( string.IsNullOrEmpty(text) ){ return; }   text = DeleteEmptyLine( text );       string[] line = text.Replace("\r\n","\n").Split(new[]{'\n','\r'});   line = DeleteArrayString(line,"");   for( int i = 0; i < line.Length; i++ ){      string[] lineValue =  line[i].Split(',');      string name = lineValue[0];      string value = lineValue[1];      if( name.Contains( "Person" ) && uiPerson.val != value ){ uiPerson.val = value; }      if( name.Contains( "AP" ) && uiTargetAP.val != value ){ uiTargetAP.val = value; }      if( name.Contains( "CtrlEnter" ) ){     if( value == "True" ){  keyControl.val = true; } else{ keyControl.val = false; }      }            for( int j = 0; j < uiPlayTimeSliders.Length; j++ ){ if( name == ( "Preset" + j.ToString() ) ){ uiPreset[j].val = value; } if( name == ( "PlayTime" + j.ToString() ) ){ uiPlayTimeSliders[j].val = float.Parse( value ); }      }   }}void GetSexName(){   bool girl = false; bool girl2 = false; bool men = false; bool men2 = false;   List<string> people = GetPeopleNamesFromScene();   foreach( string atomUID in people ){              bool feMale = GetSex( atomUID );              if( feMale ){  if( !girl ){ girlName = atomUID; girl = true; } else if( girl && !girl2 ){ girlName2 = atomUID; girl2 = true; }      }      else{ if( !men ){ menName = atomUID; men = true;  } else if( men && !men2 ){ menName2 = atomUID; men2 = true; }      }   }   }void GetSexNameTmp(){   girlNameTmp = girlName;   girlNameTmp2 = girlName2;   menNameTmp = menName;   menNameTmp2 = menName2;}        void PersonConversion(){   string text = "";   GetSexName();              SuperController.singleton.GetAtoms()           .ToList()           .ForEach((atom) =>           {              if( atom.type == "UIText"){                 text =　atom.GetStorableByID("Text").GetStringParamValue("text");                 if( !string.IsNullOrEmpty(text) ){       if( girlNameTmp != "" ){ text = text.Replace( "," + girlNameTmp,  "," + girlName ); text = text.Replace( "UIPerson/" + girlNameTmp,  "UIPerson/" + girlName ); }       if( girlNameTmp2 != "" ){ text = text.Replace( "," + girlNameTmp2,  "," + girlName2 ); text = text.Replace( "UIPerson/" + girlNameTmp2,  "UIPerson/" + girlName2 ); }       if( menNameTmp != "" ){ text = text.Replace( "," + menNameTmp,  "," + menName ); text = text.Replace( "UIPerson/" + menNameTmp,  "UIPerson/" + menName ); }       if( menNameTmp2 != "" ){ text = text.Replace( "," + menNameTmp2,  "," + menName2 ); text = text.Replace( "UIPerson/" + menNameTmp2,  "UIPerson/" + menName2 ); }            atom.GetStorableByID("Text").SetStringParamValue("text", text);                 }              }           });   GetSexNameTmp();   personConversion = true;   }       bool startNameActive = false;string girlName = "";string girlName2 = "";string menName = "";string menName2 = "";string girlNameTmp = "";string girlNameTmp2 = "";string menNameTmp = "";string menNameTmp2 = "";bool personConversion = false;string presetID = "_preset";string presetAnimeID = "_presetAnime";bool fastForward = false;float speedTmp = 0f;float limitTmp = 0f;        System.Diagnostics.Stopwatch timer = new System.Diagnostics.Stopwatch();        System.Diagnostics.Stopwatch timerStopPose = new System.Diagnostics.Stopwatch();        System.Diagnostics.Stopwatch timerMovie = new System.Diagnostics.Stopwatch();int movieNo = 0;float movieInterval = 0f;UIDynamicButton moviePlayButton;float timeInterval;float stopInterval = 0f;bool recMode = false;int waitCount = 0;   string textRec = "";string poseNowPreset;string waitNowName = "";string waitNowTmp = "";string waitPoseTmp = "";string waitNextTmp = "";   List<string> waitEndList = new List<string>();   List<string> stopEndList = new List<string>();   List<string> textEndList = new List<string>();bool posePause = false;bool poseLoad;   string nextPoseText = "";   List<string> endControllerList = new List<string>();   List<string> endScaleList = new List<string>();string[,] xyzEnd;int xyzEndId;   List<string> atomSkipTypeList = new List<string>{ "Person", "InvisibleLight", "AnimationStep" };   List<string> atomSkipNameList = new List<string>{ "__", "WindowCamera", "PlayerNavigation",  "CameraRig", "CoreControl" };   List<string> receiverAnimeList = new List<string>{ "PersonController:", "Atom:", "カメラ:" };   List<string> targetAtomList = new List<string>{ "ButtonColor", "Panel", "TextColor",  "scale", "rescaleObject",   "plugin#0_MacGruber.PostMagic.Bloom" , "plugin#0_MacGruber.PostMagic.DepthOfField" };   List<string> targetSkipList = new List<string>{ "simTexture", "Hair", "WrapControl", "Preset", "ItemControl" };   List<string> receiveUrlList = new List<string>{ "Url","simTexture" };   List<string> targetLightList = new List<string>{ "Light" };   List<string> receiverClothingList = new List<string>{ "clothing:","hair:" };   List<string> targetClothingList = new List<string>{ "Sim", "Material" };   List<string> targetAPList = new List<string>{ "AnimationPattern" };   List<string> targetPluginList = new List<string>{ "dami" };   List<string> skipPluginList = new List<string>{ "AutoLabia", "ExplosionLimiter"  };   List<string> targetSkinList = new List<string>{ "skin", "textures" };   List<string> targetSkinBaseList = new List<string>{ "DiffuseUrl" };   List<string> targetSkinSkipList = new List<string>{ "customTexture" };   List<string> targetBreastList = new List<string>{ "BreastControl", "BreastPhysicsMesh" };int gamePoint = 0;string gamePointID = "_gamePoint";string gameTimerID = "_gameTimer";   List<string> pointEndList = new List<string>();        System.Diagnostics.Stopwatch gameTimer = new System.Diagnostics.Stopwatch();float gameTimerLimit = 0f;   List<string> gameTimerEndList = new List<string>();JSONStorableStringChooser uiGameTimerPlay;JSONStorableStringChooser[] uiKeyboards =new JSONStorableStringChooser[4];    KeyCode[] _toggleKeys = new KeyCode[4]{ KeyCode.None,KeyCode.None,KeyCode.None,KeyCode.None };JSONStorableStringChooser[] uiEventPlays =new JSONStorableStringChooser[4];JSONStorableStringChooser uiPresetAnime;JSONStorableStringChooser uiStart;JSONStorableStringChooser uiEnd;JSONStorableStringChooser uiNextPlay;JSONStorableBool randomSpeed;JSONStorableBool poseLoop;JSONStorableBool allCycle;JSONStorableBool poseSet;JSONStorableBool cameraAction;JSONStorableBool keyAction;JSONStorableBool saveUIReset;JSONStorableBool replay;JSONStorableBool selectPlay;JSONStorableBool movieLoop;JSONStorableBool clothingReset;JSONStorableBool hairReset;JSONStorableBool keyControl;JSONStorableBool movieRandom;JSONStorableFloat[] uiPlayTimeSliders= new JSONStorableFloat[20];JSONStorableFloat speedSlider;JSONStorableFloat limitSlider;JSONStorableFloat movieSlider;JSONStorableFloat movieRandomMax;System.Random r = new System.Random();float movieSliderTmp;JSONStorableStringChooser uiPerson;JSONStorableStringChooser uiTargetAP;JSONStorableStringChooser uiPresetSave;JSONStorableStringChooser[] uiPreset= new JSONStorableStringChooser[20];JSONStorableStringChooser uiHairFav;JSONStorableStringChooser uiClothingFav;JSONStorableStringChooser uiSource;JSONStorableStringChooser uiAudioClip;JSONStorableFloat uiVolumeSlider;JSONStorableBool uiSoundLoop;JSONStorableStringChooser uiSubText;string sourceTemp;string audioTemp;string presetAnimeTemp;string personTemp;string targetAPTemp;string presetSaveTemp;string presetResetTemp;string hairFavTemp;string clothingFavTemp;string[] uiPresetTemps = new string[20];bool[] playActionTemps = new bool[20];bool selectedUI = false;        AnimationPattern animationPattern;JSONStorableFloat currentTime;float totalTime;List<NamedAudioClip> audioClips = new List<NamedAudioClip>();NamedAudioClip audioClip;AudioSourceControl source;bool vector;JSONStorableFloat xSlider; JSONStorableFloat xMSlider;JSONStorableFloat ySlider;JSONStorableFloat yMSlider; JSONStorableFloat zSlider;JSONStorableFloat zMSlider;bool japanese = false;string langText = "";        void LateUpdate()        {            try            {      if( !startNameActive && Input.GetMouseButtonDown(0) ){ startNameActive = true; GetSexName(); GetSexNameTmp();  }      if( uiPresetAnime.val != "none" ){ TempTargetPresetAnimeUpdate();  }                  if( stopInterval != 0f ){    timer.Stop();            if( timerStopPose.ElapsedMilliseconds > ( stopInterval * 1000) ){       stopInterval = 0f; timerStopPose.Reset(); timerStopPose.Stop();timer.Start();     }            else{ return; }         }                  if( gameTimerLimit != 0f ){            if( gameTimer.ElapsedMilliseconds >= ( gameTimerLimit * 10000) ){       gameTimerLimit = 0f; gameTimer.Reset(); gameTimer.Stop();       if( uiGameTimerPlay.val != "none" )          poseLoop.val = false; uiNextPlay.val = "none";  uiPresetSave.val = uiGameTimerPlay.val; uiGameTimerPlay.val = "none";  EndClear(); PresetLoad( uiPresetSave.val );    }       Atom atom = SuperController.singleton.GetAtomByUid(gameTimerID);       if( atom ){      float gameTime = ( gameTimerLimit * 10000) - gameTimer.ElapsedMilliseconds;      SetString( atom.name, "Text", "text", gameTime.ToString() );    }  }                  if( uiKeyboards[0].val != "None" ){            if( !recMode ){           for( int id = 0; id < uiKeyboards.Length; id++ ){                   if( uiKeyboards[id].val != "None" && uiEventPlays[id].val != "none" ){                       ApplyToggleKey( uiKeyboards[id].val, id );                            if (_toggleKeys[id] != KeyCode.None && Input.GetKeyDown(_toggleKeys[id])){               textEndList = new List<string>(); EndClear(); PresetLoad( uiEventPlays[id].val );            }          }               }            }         }                   if( waitNowName != "" && nextPoseText == "" ){ GetNextPoseText(); }                  if( stopInterval == 0f && !posePause && waitNowName == "" && nextPoseText != "" && waitEndList.Count > 0 ){ PoseLoad(); }      if( movieInterval != 0f && uiTargetAP.val == "none" ){        if( timerMovie.ElapsedMilliseconds == 0f ){ MovieSync(); }        else if( timerMovie.ElapsedMilliseconds > ( movieInterval * 1000) ){ MovieChange(); } }      if( uiTargetAP.val != "none" && uiPerson.val!="none" ){ SyncPlay();  }    if( keyControl.val && Input.GetKey(KeyCode.LeftShift) && Input.GetKeyDown(KeyCode.Return) ){          if( uiTargetAP.val != "none" ){          for( int i = 0; i < uiPlayTimeSliders.Length; i++ ){ playActionTemps[i] = false; }        GetAnimationPattern( uiTargetAP.val );                    animationPattern.ResetAndPlay();     }          else{ movieSliderTmp = movieSlider.val; MovieStart(); } }            }            catch (Exception e)            {                SuperController.LogError("Exception caught: " + e);            }        }        public override void Init()        {            try            {pluginLabelJSON.val="Preset Play";        _vamFilePath = Application.dataPath.Substring(0,Application.dataPath.Length-8).Replace('/','\\');         SuperController.singleton.ClearErrors();  UIDynamicPopup udp; UIDynamic spacer; List<string> targetChoices;        spacer = CreateSpacer(false);            spacer.height = 0f;     spacer = CreateSpacer(true);            spacer.height = 0f; vector = true;           CreateUIPerson();  CreateUISavePreset();  JSONStorableAction _executeAction = new JSONStorableAction("LoadPreset", () =>{     textEndList = new List<string>(); EndClear(); PresetLoad( uiPresetSave.val ); });              RegisterAction(_executeAction); JSONStorableAction _moviePlayAction = new JSONStorableAction("MoviePlay", () =>{ movieSliderTmp = movieSlider.val; MovieStart(); });              RegisterAction(_moviePlayAction); JSONStorableAction _moviePauseAction = new JSONStorableAction("MoviePause", () =>{     posePause =! posePause; personConversion = false; });              RegisterAction(_moviePauseAction); JSONStorableAction _movieStopAction = new JSONStorableAction("MovieStop", () =>{ MovieStop(); });              RegisterAction(_movieStopAction); JSONStorableAction _fastForward = new JSONStorableAction("Fast Forward", () =>{ FastForward(); });              RegisterAction(_fastForward); JSONStorableAction _nextPose = new JSONStorableAction("Next Pose", () =>{ SearchPose("Next"); });              RegisterAction(_nextPose); JSONStorableAction _backPose = new JSONStorableAction("Back Pose", () =>{ SearchPose("Back"); });              RegisterAction(_backPose); JSONStorableAction _cameraOn = new JSONStorableAction("CameraOn", () =>{ cameraAction.val = true;  });              RegisterAction(_cameraOn); JSONStorableAction _cameraOff = new JSONStorableAction("CameraOff", () =>{ cameraAction.val = false;  });              RegisterAction(_cameraOff); JSONStorableAction _animePresetStop = new JSONStorableAction("AnimePreset Stop", () =>{uiPresetAnime.val = "none"; uiTargetAP.val = "none"; presetAnimeTemp = uiPresetAnime.val; targetAPTemp = uiTargetAP.val; ClearPosePreset(); });              RegisterAction(_animePresetStop);  JSONStorableAction _gameReset = new JSONStorableAction("GameReset", () =>{ GameReset(); });              RegisterAction(_gameReset);  JSONStorableAction _PauseClear = new JSONStorableAction("PauseClear", () =>{     PauseClear(); personConversion = false; });              RegisterAction(_PauseClear);   CreateUISourceTarget();  CreateUIAudioTarget();  CreateUIVolumeSlider();          clothingReset = new JSONStorableBool("服リセット", false);         RegisterBool(clothingReset);          hairReset = new JSONStorableBool("髪リセット", false);         RegisterBool(hairReset);             CreateUISubTarget();     CreateGravityControl();   vector = false;          selectPlay = new JSONStorableBool("プリセット選択Play", true);         RegisterBool(selectPlay);          replay = new JSONStorableBool("Replay", true);         RegisterBool(replay);          saveUIReset = new JSONStorableBool("デフォルト設定に戻す", true);          keyAction = new JSONStorableBool("キーボード有効", false);         RegisterBool(keyAction);          cameraAction = new JSONStorableBool("Camera On", true);         RegisterBool(cameraAction);         CreateToggle(cameraAction, vector);  if( japanese ){ langText = "ポーズ強制一致"; }else{ langText = "Forced pose"; }         poseSet = new JSONStorableBool(langText, true);         RegisterBool(poseSet);         CreateToggle(poseSet, vector);  if( japanese ){ langText = "Cycle全値取得"; }else{ langText = "Save all cycle "; }         allCycle = new JSONStorableBool(langText, false);         RegisterBool(allCycle);         CreateToggle(allCycle, vector);  if( japanese ){ langText = "Poseループ"; }else{ langText = "Pose Loop"; }         poseLoop = new JSONStorableBool( langText, false );         CreateToggle( poseLoop, vector);          CreateUIGameTimerPlay();      for( int i = 0; i < uiKeyboards.Length; i++ ){        CreateUIKeyboards(i);       CreateUIEventPlays(i); }  if( japanese ){ langText = "スピードランダム"; }else{ langText = "Random speed"; }         randomSpeed = new JSONStorableBool( langText, false );         CreateToggle( randomSpeed, vector);  SpeedSlider();  LimitTimeSlider();              CreateUINextPlay();  CreateUIPoseStart(); CreateUIPoseEnd();       List<string> people = GetPeopleNamesFromScene(); loadFilePath = new JSONStorableString[people.Count()]; selectPoseButton = new UIDynamicButton[people.Count()];    personID = 0;         foreach ( string atomUID in people ){            CreateSelectPoseButton( personID, atomUID );            personID++;         }          MovieSlider();         movieRandom = new JSONStorableBool( "時間ランダム変化", false );            RegisterBool(movieRandom);          MovieMaxSlider();         if( japanese ){ langText = "ムービーループ"; }else{ langText = "Movie Loop"; }         movieLoop = new JSONStorableBool( langText, true );            RegisterBool(movieLoop);         CreateToggle( movieLoop, vector);          CreateMoviePlayButton();     spacer = CreateSpacer(vector);  spacer.height = 10f;     CreateUIPresetAnime();          CreateUIAP(); if( containingAtom.type == "AnimationPattern" ){     uiTargetAP.val = containingAtom.name;    GetAnimationPattern( uiTargetAP.val );     animationPattern.ResetAnimation(); }          keyControl = new JSONStorableBool("Ctrl+Enter Play", true);                    for( int i = 0; i < uiPlayTimeSliders.Length; i++ ){        CreateUIPreset(i);                CreatePlayTimeSlider(i); }RefreshListChoices();            }            catch (Exception e)            {                SuperController.LogError("Exception caught: " + e);            }        }string _vamFilePath;int personID;JSONStorableString[] loadFilePath = new JSONStorableString[10];UIDynamicButton[] selectPoseButton = new UIDynamicButton[10];        void CreateSelectPoseButton( int id, string atomName ){   loadFilePath[id] = new JSONStorableString ( atomName, "" );   RegisterString( loadFilePath[id] );      }        void CreateMoviePlayButton(){   if( japanese ){ langText = "ムービーPlay"; }else{ langText = "Movie Play"; }   moviePlayButton = CreateButton(langText, vector);   moviePlayButton.height = 10f;   moviePlayButton.button.onClick.AddListener(delegate (){ movieSliderTmp = movieSlider.val; MovieStart(); });}        void FastForward(){   if ( containingAtom.name != "__PresetAdminister" ){ return; }   fastForward =! fastForward;    if( fastForward ){ speedTmp = speedSlider.val;  limitTmp = limitSlider.val; speedSlider.val = 35f; limitSlider.val = 7f; }   else if( !fastForward ){ speedRestore(); }}        void speedRestore(){   fastForward = false;    if( speedTmp != 0f ){ speedSlider.val = speedTmp; } if( limitTmp != 0f ){ limitSlider.val = limitTmp; }   speedTmp = 0f; limitTmp = 0f;}        void SearchPose( string vector )        {   if ( containingAtom.name != "__PresetAdminister" ){ return; }   poseLoop.val = false;   uiNextPlay.val = "none";   bool nowPose = false;   int searchNo = 0;   List<string> presetList = GetPresetListChoices( true );   if( uiStart.val == "none" && uiEnd.val == "none" ){ presetList = GetPoseListRangeChoices(); }    presetList.Remove("none"); presetList.Remove(presetID + "PoseBk");           for( int i = 0; i <= presetList.Count; i++ ){               if ( nowPose ){ EndClear(); PresetLoad( presetList[searchNo] ); uiPresetSave.val = presetList[searchNo]; break; }              if ( !nowPose && uiPresetSave.val == presetList[i] ){                 if ( vector == "Next" && presetList[i] != presetList.Last() ){ nowPose = true; searchNo = i+1; movieNo++; }                 if ( vector == "Back" && presetList[i] != presetList.First() ){ nowPose = true; searchNo = i-1; movieNo--; }              }   }}        void CreateUIPresetAnime(){   List<string> targetChoices = GetAtomListChoices("UIText",presetAnimeID);   uiPresetAnime = new JSONStorableStringChooser("AnimePreset", targetChoices, "none", "プリセット\nアニメ");   RegisterStringChooser(uiPresetAnime);   UIDynamicPopup udp = CreateScrollablePopup(uiPresetAnime, vector);   udp.popup.onOpenPopupHandlers += RefreshListChoices;}        void CreateUISubTarget(){   List<string> targetChoices = new List<string>();   uiSubText = new JSONStorableStringChooser("SubText", targetChoices, "字幕", "字幕");}        void CreateUISourceTarget(){   List<string> targetChoices = new List<string>();   uiSource = new JSONStorableStringChooser("AudioSource", targetChoices, "none", "音源");}        void CreateUIAudioTarget(){   List<string> targetChoices = new List<string>();   uiAudioClip = new JSONStorableStringChooser("AudioClip", targetChoices, "none", "Audio");}        void CreateUIVolumeSlider(){   uiVolumeSlider = new JSONStorableFloat("Volume", 1f, 0f, 1f, true);           uiVolumeSlider.storeType = JSONStorableParam.StoreType.Full;              uiSoundLoop = new JSONStorableBool("ループ", true);}    void ApplyToggleKey(string val, int i ){ _toggleKeys[i] = (KeyCode)Enum.Parse(typeof(KeyCode), val); }        void CreateUIKeyboards(int i){           var keys = Enum.GetNames(typeof(KeyCode)).ToList();   if( japanese ){ langText = "キーボード"; }else{ langText = "ToggleKey"; }           uiKeyboards[i] = new JSONStorableStringChooser("ToggleKey"+i, keys, "None", langText);           RegisterStringChooser(uiKeyboards[i]);}        void CreateUIGameTimerPlay(){   List<string> targetChoices = new List<string>();   if( japanese ){ langText = "終了再生"; }else{ langText = "End Play"; }   uiGameTimerPlay = new JSONStorableStringChooser("GameTimerPlay", targetChoices, "none", langText);}        void CreateUIEventPlays(int i){   List<string> targetChoices = new List<string>();   if( japanese ){ langText = "再生"; }else{ langText = "Event Play"; }   uiEventPlays[i] = new JSONStorableStringChooser("EventPlay"+i, targetChoices, "none", langText);           RegisterStringChooser(uiEventPlays[i]);}        void CreateUINextPlay(){   List<string> targetChoices = new List<string>();   if( japanese ){ langText = "次の再生Pose"; }else{ langText = "NextPlayPose"; }   uiNextPlay = new JSONStorableStringChooser("Next Play", targetChoices, "none", langText);}        void CreateUIPoseStart(){   List<string> targetChoices = new List<string>();   if( japanese ){ langText = "開始"; }else{ langText = "Start"; }   uiStart = new JSONStorableStringChooser("StartPreset", targetChoices, "none", langText);   RegisterStringChooser(uiStart);   UIDynamicPopup udp = CreateScrollablePopup(uiStart, vector);   udp.popup.onOpenPopupHandlers += RefreshListChoices;}        void CreateUIPoseEnd(){   List<string> targetChoices = new List<string>();   if( japanese ){ langText = "終了"; }else{ langText = "End"; }   uiEnd = new JSONStorableStringChooser("EndPreset", targetChoices, "none", langText);   RegisterStringChooser(uiEnd);   UIDynamicPopup udp = CreateScrollablePopup(uiEnd, vector);   udp.popup.onOpenPopupHandlers += RefreshListChoices;}        void CreateUIPerson(){   List<string> targetChoices = new List<string>();   uiPerson = new JSONStorableStringChooser("人物", targetChoices, "女優", "人物");}        void CreateUIAP(){   List<string> targetChoices = new List<string>();   uiTargetAP = new JSONStorableStringChooser("AP", targetChoices, "none", "Target\nAP");}        void CreateUISavePreset(){   List<string> targetChoices = new List<string>();   uiPresetSave = new JSONStorableStringChooser("Preset", targetChoices, "none", "Preset" );   RegisterStringChooser(uiPresetSave);   UIDynamicPopup udp = CreateScrollablePopup(uiPresetSave, vector);   udp.popup.onOpenPopupHandlers += RefreshListChoices;}        void CreateUIPreset(int i){   List<string> targetChoices = new List<string>();   uiPreset[i] = new JSONStorableStringChooser("Preset"+i, targetChoices, "none", "プリセット"+(i+1));   RegisterStringChooser(uiPreset[i]);}        void SpeedSlider(){    if( japanese ){ langText = "Poseスピード"; }else{ langText = "Pose Speed"; }            speedSlider = new JSONStorableFloat(langText, 5f, 1f, 50f,true);            speedSlider.storeType = JSONStorableParam.StoreType.Full;            CreateSlider(speedSlider, vector);}        void LimitTimeSlider(){    if( japanese ){ langText = "Pose変化待ちリミット"; }else{ langText = "Pose LimitTime"; }            limitSlider = new JSONStorableFloat(langText, 7f, 1f, 20f,true);            limitSlider.storeType = JSONStorableParam.StoreType.Full;            RegisterFloat(limitSlider);            CreateSlider(limitSlider, vector);}        void MovieSlider(){    if( japanese ){ langText = "ムービー切り替え時間"; }else{ langText = "Pose interval time"; }            movieSlider = new JSONStorableFloat(langText, 5f, 0.01f, 50f,true);            movieSlider.storeType = JSONStorableParam.StoreType.Full;            RegisterFloat(movieSlider);            CreateSlider(movieSlider, vector);}        void MovieMaxSlider(){            movieRandomMax = new JSONStorableFloat("変化量", 5f, 0.01f, 50f,true);            movieRandomMax.storeType = JSONStorableParam.StoreType.Full;            RegisterFloat(movieRandomMax);}        void CreatePlayTimeSlider(int i){    uiPlayTimeSliders[i] = new JSONStorableFloat("PlayTime"+(i+1), 1000f, 0.01f, 0.01f,true);            uiPlayTimeSliders[i].storeType = JSONStorableParam.StoreType.Full;}private JSONStorableFloat CreateFloatSlider(string name, float defaultValue, float minValue, float maxValue, bool Left = false){   JSONStorableFloat storable = new JSONStorableFloat(name, defaultValue, minValue, maxValue, true, true);   storable.storeType = JSONStorableParam.StoreType.Full;   CreateSlider(storable, Left);   RegisterFloat(storable);   return storable;}        void CreateGravityControl(){  GravityControl gravity;  gravity = SuperController.singleton.GetAtomByUid("CoreControl").GetStorableByID("Gravity") as GravityControl;  xSlider = CreateFloatSlider("X", gravity.gravityX, -10f, 10f, vector);  ySlider = CreateFloatSlider("Y", gravity.gravityY, -10f, 10f, vector);  zSlider = CreateFloatSlider("Z", gravity.gravityZ, -10f, 10f, vector);  xMSlider = CreateFloatSlider("X multiplier", 1f, -10f, 10f, vector);  yMSlider = CreateFloatSlider("Y multiplier", 1f, -10f, 10f, vector);  zMSlider = CreateFloatSlider("Z multiplier", 1f, -10f, 10f, vector);  xSlider.slider.onValueChanged.AddListener((float value) => {gravity.gravityX = xSlider.val * xMSlider.val;});  ySlider.slider.onValueChanged.AddListener((float value) => {gravity.gravityY = ySlider.val * yMSlider.val;});  zSlider.slider.onValueChanged.AddListener((float value) => {gravity.gravityZ = zSlider.val * zMSlider.val;});  xMSlider.slider.onValueChanged.AddListener((float value) => {gravity.gravityX = xSlider.val * xMSlider.val;});  yMSlider.slider.onValueChanged.AddListener((float value) => {gravity.gravityY = ySlider.val * yMSlider.val;});  zMSlider.slider.onValueChanged.AddListener((float value) => {gravity.gravityZ = zSlider.val * zMSlider.val;});  UIDynamicButton resetGravityButton = CreateButton("Reset settings", true);  resetGravityButton.button.onClick.AddListener(delegate (){xSlider.val  = 0;xMSlider.val = 1;ySlider.val  = -9.81f;yMSlider.val = 1;zSlider.val  = 0;zMSlider.val = 1;});}        void ResetAnimation(AnimationPattern animationPattern)        {            animationPattern.Pause();            animationPattern.ResetAnimation();}        void LogMsg(string msg)        {            }        void LogMsg2(string msg)        {    SuperController.singleton.ClearErrors();    SuperController.LogMessage(msg);}        bool GetIsNumeric( string value ){    double d;    if( double.TryParse(value, out d) ){ return true; }    else{ return false; }}        string GetAtomText(string atomName)        {    Atom atom = SuperController.singleton.GetAtomByUid(atomName);            if(atom==null){return null; }    string textValue=　atom.GetStorableByID("Text").GetStringParamValue("text");    return(textValue);}        string DeleteEmptyLine(string text)        {   text = Regex.Replace   (     text,     "^[\r\n]+",     string.Empty,     RegexOptions.Multiline    );   return text;}        private IEnumerator AddTypeAtom(string atomType,string atomName, string controllerName, string controllerOn, float posX, float posY, float posZ, float rot1, float rot2, float rot3, float rot4 )        {    yield return StartCoroutine(SuperController.singleton.AddAtomByType(atomType, atomName, false));    Atom atom= SuperController.singleton.GetAtomByUid( atomName );          　if( atom != null ){       string action = "none";       SetTextAtomOn( atomName, atomType, controllerOn, action );       SetTextAtomTransform( atomName, controllerName, posX, posY, posZ, rot1, rot2, rot3, rot4 );    }        }        private IEnumerator AddAtomMatch( string atomType, string atomName, string controllerName, string controllerOn, float posX, float posY, float posZ, float rot1, float rot2, float rot3, float rot4 )        {  bool match = false;          SuperController.singleton.GetAtoms()          .ToList()          .ForEach((atom) =>          {if(atom.type == atomType && atom.name == atomName){ match = true ; }          });  if( !match ) {  yield return StartCoroutine(AddTypeAtom(atomType, atomName, controllerName, controllerOn, posX, posY, posZ, rot1, rot2, rot3, rot4)); }}        string[] DeleteArrayString(string[] array,string delString)        {var list = new List<string>();      list.AddRange(array);            list.Remove(delString);      array = list.ToArray();return(array);}   }}